#include <stdint.h>
#include <stdio.h>

#include "devices.h"
#include "instruments.h"
#include "drv_instrument.h"
#include "drv_dac.h"

#define DAC_CHAN_X 0
#define DAC_CHAN_Y 1

dac_t *dac;
instrument_t *ctlpanel;

void init() {
    dac = dac_open(DAC_1);
    ctlpanel = instrument_open(CTLPANEL);
}

void main() {
    init();
    printf("NOS031002 started.\n");
    uint32_t xv,yv,lastx,lasty;
    bool upd;
    lastx = 999;
    lasty = 999;
    uint8_t gen1x,gen1y,gen2x,gen2y,mul1x,mul1y,mul2x,mul2y;
    uint32_t tim, ltim;
    gen1x = 0;
    gen1y = 0;
    gen2x = 0;
    gen2y = 0;
    mul1x = 0;
    mul1y = 0;
    mul2x = 1;
    mul2y = 1;
    tim = 0;
    ltim = 0;
    for (;;) {
        tim++;
        gen2x = instrument_get_value(ctlpanel,CTLPANEL_XIN);
        gen2y = instrument_get_value(ctlpanel,CTLPANEL_YIN);
        if (tim<1000) continue;
        gen1x = (gen1x+1) % 256;
        gen1y = (gen1y+3) % 256;
        xv = (mul1x*gen1x) + (mul2x*gen2x);
        yv = (mul1y*gen1y) + (mul2y*gen2y);
        upd = false;
        if ((xv!=lastx) || (yv!=lasty)) {
            upd = true;
            lastx = xv;
            lasty = yv;
        }
        if (upd) {
           /* printf("X=%d Y=%d\n",xv,yv); */
           ltim++;
           if (ltim>2) {
              instrument_set_value(ctlpanel,CTLPANEL_XOUT,xv);
              instrument_set_value(ctlpanel,CTLPANEL_YOUT,yv);
              ltim = 0;
           }
           dac_write(dac,DAC_CHAN_X,xv,false);
           dac_write(dac,DAC_CHAN_Y,yv,true);
        }
    }
}

